
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import java.util.Stack;
import java.io.*;

public class Cadre extends JFrame {
	static final Color[] couleurs={Color.BLACK,Color.RED,Color.GREEN,Color.YELLOW,Color.BLUE,
			Color.MAGENTA,Color.CYAN,Color.WHITE,Color.GRAY,Color.LIGHT_GRAY,new Color(128,0,0),new Color(0,128,0),
			new Color(0,0,128),Color.ORANGE,Color.PINK,new Color(128,0,255),new Color(153,102,0)};
	static Stack pile_historique = new Stack();
	/* Rpertorie tous les numros de
	tortues visible  l'cran*/
	Stack tortues_visibles = new Stack(); 
 
	int index_historique = 0;

	// Contient le chemin du fichiers actuellement
	// ouvert
	static String path = null;
	String tmp_path = null; // Lorsqu'on ouvre un fichier
	//0 si mode fenetre 1 si mode enroule 2 si mode clos
	static int etat_fenetre = 0;
	static int police = Panneau_Police.police_id(Logo.police); // numro

	// identifiant de la police de l'interface
	static int police_etiquette = police; // numro identifiant la police de la

	// fenetre graphique avec "etiquette"
	static int police_ecris = police; // numro identifiant la police de

	// l'historique avec "ecris"

	MenuListener menulistener = new MenuListener(this);
	Editeur editeur = new Editeur(this);
	JPanel contentPane;
	JMenuBar jMenuBar1 = new JMenuBar();
	JMenu jMenuFile = new JMenu();
	JMenu jMenuHelp = new JMenu();
	JMenuItem jMenuHelpAbout = new JMenuItem();
	JMenuItem jMenuHelpLicence = new JMenuItem();
	JMenuItem jMenuHelplicencefrancais = new JMenuItem();
	BorderLayout borderLayout1 = new BorderLayout();
	JPanel jPanel1 = new JPanel();
//	static JTextField commande = new JTextField();
	ZoneCommande commande=new ZoneCommande(this);
		
	JLabel jLabel1 = new JLabel();
	BorderLayout borderLayout2 = new BorderLayout();
	JSplitPane jSplitPane1 = new JSplitPane();
	JScrollPane jScrollPane1 = new JScrollPane();
	Ardoise ardoise1 = new Ardoise(jScrollPane1);
	PanneauHistorique panneauHistorique1 = new PanneauHistorique(this);
	Tortue tortue = new Tortue(this);
	Tortue[] tortues = new Tortue[Logo.tortues];
	Color couleurfond = Color.white;
	boolean error = false;
	boolean stop = false;
	Primitive primitive = null;
	Affichage affichage = null;
	BarreDefilement barre = new BarreDefilement();
	LancePrimitive lanceprim;
	static Stack globale = new Stack(); //Pile contenant les noms des variables globales
	static Stack valeur = new Stack(); //Pile contenant leur valeurs de ces variables
	static boolean mode_classique=true; // true si classique false si animation
	static boolean mode_trace=false; // true si le mode trace est enclenche (permet de suivre les procdures)
	static long chrono = 0;
	Son son = new Son(this);
	Touche touche = new Touche();
	Interprete interprete = new Interprete(this);
	JMenu jMenuEdition = new JMenu();
	JMenuItem jMenuEditionCopier = new JMenuItem();
	JMenuItem jMenuEditionColler = new JMenuItem();
	JMenuItem jMenuEditionCouper = new JMenuItem();
	JMenuItem jMenuFileNouveau = new JMenuItem();
	JMenuItem jMenuFileEnregistrer = new JMenuItem();
	JMenuItem jMenuFileEnregistrer_sous = new JMenuItem();
	JMenuItem jMenuFileOuvrir = new JMenuItem();
	JMenuItem jMenuFileQuitter = new JMenuItem();
	JMenu jMenuCapture = new JMenu();
	JMenuItem jMenuItem1 = new JMenuItem();
	JMenuItem jMenuItem2 = new JMenuItem();
	JMenuItem jMenuItem3 = new JMenuItem();
	JMenu jMenuZoneTexte=new JMenu();
	JMenuItem jMenuZoneTexteItem = new JMenuItem();
	
	JMenu jMenuOptions = new JMenu();
	JMenuItem jMenuOptionsCouleurCrayon = new JMenuItem();
	JMenuItem jMenuOptionsCouleurFond = new JMenuItem();
	JMenuItem jMenuOptionsDemarrage = new JMenuItem();
	JMenuItem jMenuOptionsPreference = new JMenuItem();
	JMenuItem jMenuOptionsTraduction = new JMenuItem();
	Popup jpop = new Popup(menulistener, commande);
	class BarreDefilement implements AdjustmentListener { //Si on dplace les
		// srollbar
		public BarreDefilement() {
		} // Il faut indiquer  la tortue que

		public void adjustmentValueChanged(AdjustmentEvent e) { //la zone de
			// dessin a
			// change
			if (null != primitive) {
				primitive.graph = ardoise1.getGraphics();
			}
		}
	}

	/** Construire le cadre */
	public Cadre() {
		
		// initialise
		tortue.id = 0;
		tortues_visibles.push(String.valueOf("0"));
		for (int i = 0; i < tortues.length; i++) { //initialisation de
			// l'ensemble des tortues
			if (i == 0)
				tortues[i] = tortue;
			else
				tortues[i] = null;
		}
		this.setText();
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Initialiser le composant */
	private void jbInit() throws Exception {
		setIconImage(Toolkit.getDefaultToolkit().createImage(
		Cadre.class.getResource("icone.png")));
		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(borderLayout1);
		Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
		this.setSize(new Dimension(d.width,d.height*9/10));
		this.setTitle("XLogo");
		
		jMenuHelpLicence.addActionListener(menulistener);
		jMenuHelpAbout.addActionListener(menulistener);
		jMenuHelplicencefrancais.addActionListener(menulistener);
		
		
		/*commande.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				commande_actionPerformed(e);
			}
		});*/
		commande.setPreferredSize(new Dimension(300,18*Logo.police.getSize()/10));
		jPanel1.setLayout(borderLayout2);
		jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
		panneauHistorique1.setMinimumSize(new Dimension(600, 40));

		jMenuEditionCopier.addActionListener(menulistener);
		jMenuEditionColler.addActionListener(menulistener);
		jMenuEditionCouper.addActionListener(menulistener);

		jMenuFileOuvrir.addActionListener(menulistener);
		jMenuFileNouveau.addActionListener(menulistener);
		jMenuFileNouveau.setEnabled(false);
		jMenuFileEnregistrer_sous.addActionListener(menulistener);
		jMenuFileEnregistrer.addActionListener(menulistener);
		jMenuFileEnregistrer.setEnabled(false);
		jMenuFileQuitter.addActionListener(menulistener);

		jMenuItem1.addActionListener(menulistener);
		jMenuItem2.addActionListener(menulistener);
		jMenuItem3.addActionListener(menulistener);
		jMenuZoneTexteItem.addActionListener(menulistener);

		jMenuOptionsDemarrage.addActionListener(menulistener);
		jMenuOptionsCouleurCrayon.addActionListener(menulistener);
		jMenuOptionsCouleurFond.addActionListener(menulistener);
		jMenuOptionsPreference.addActionListener(menulistener);
		jMenuOptionsTraduction.addActionListener(menulistener);

		jMenuFile.add(jMenuFileNouveau);
		jMenuFile.add(jMenuFileOuvrir);
		jMenuFile.add(jMenuFileEnregistrer_sous);
		jMenuFile.add(jMenuFileEnregistrer);
		jMenuFile.add(jMenuCapture);
		jMenuZoneTexte.add(jMenuZoneTexteItem);
		jMenuFile.add(jMenuZoneTexte);
		jMenuFile.add(jMenuFileQuitter);
		jMenuHelp.add(jMenuHelpLicence);
		jMenuHelp.add(jMenuHelplicencefrancais);
		jMenuHelp.add(jMenuHelpAbout);
		jMenuBar1.add(jMenuFile);
		jMenuBar1.add(jMenuEdition);
		jMenuBar1.add(jMenuOptions);
		jMenuBar1.add(jMenuHelp);
		contentPane.add(jPanel1, BorderLayout.NORTH);
		jPanel1.add(jLabel1, BorderLayout.WEST);
		jPanel1.add(commande, BorderLayout.CENTER);
		contentPane.add(jSplitPane1, BorderLayout.CENTER);
		jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
		jScrollPane1.getViewport().add(ardoise1, null);
		jScrollPane1.getHorizontalScrollBar().setBlockIncrement(5);
		jScrollPane1.getVerticalScrollBar().setBlockIncrement(5);
		jScrollPane1.getHorizontalScrollBar().addAdjustmentListener(barre);
		jScrollPane1.getVerticalScrollBar().addAdjustmentListener(barre);
		jSplitPane1.add(panneauHistorique1, JSplitPane.RIGHT);
		jMenuEdition.add(jMenuEditionCopier);
		jMenuEdition.add(jMenuEditionColler);
		jMenuEdition.add(jMenuEditionCouper);
		jMenuCapture.add(jMenuItem1);
		jMenuCapture.add(jMenuItem2);
		jMenuCapture.add(jMenuItem3);
		jMenuOptions.add(jMenuOptionsCouleurCrayon);
		jMenuOptions.add(jMenuOptionsCouleurFond);
		jMenuOptions.add(jMenuOptionsDemarrage);
		jMenuOptions.add(jMenuOptionsTraduction);
		jMenuOptions.add(jMenuOptionsPreference);

		MouseListener popupListener = new PopupListener();
		commande.addMouseListener(popupListener);

		this.setJMenuBar(jMenuBar1);
		jSplitPane1.setResizeWeight(0.8);
		commande.addKeyListener(touche);
	}

	public void setText() {
		//		System.out.println(Logo.police.getName());
		setFont(Logo.police);
		// Texte interne  utiliser pour JFileChooser et JColorChooser
		UIManager.put("FileChooser.cancelButtonText", Logo.messages
				.getString("annuler"));
		UIManager.put("FileChooser.cancelButtonToolTipText", Logo.messages
				.getString("annuler"));
		UIManager.put("FileChooser.fileNameLabelText", Logo.messages
				.getString("nom_du_fichier"));
		UIManager.put("FileChooser.upFolderToolTipText", Logo.messages
				.getString("dossier_parent"));
		UIManager.put("FileChooser.lookInLabelText", Logo.messages
				.getString("rechercher_dans"));

		UIManager.put("FileChooser.newFolderToolTipText", Logo.messages
				.getString("nouveau_dossier"));
		UIManager.put("FileChooser.homeFolderToolTipText", Logo.messages
				.getString("repertoire_accueil"));
		UIManager.put("FileChooser.filesOfTypeLabelText", Logo.messages
				.getString("fichier_du_type"));
		UIManager.put("FileChooser.helpButtonText", Logo.messages
				.getString("aide"));

		UIManager.put("ColorChooser.rgbNameText", Logo.messages
				.getString("rgb"));
		UIManager.put("ColorChooser.rgbBlueText", Logo.messages
				.getString("bleu"));
		UIManager.put("ColorChooser.rgbGreenText", Logo.messages
				.getString("vert"));
		UIManager.put("ColorChooser.rgbRedText", Logo.messages
				.getString("rouge"));

		UIManager.put("ColorChooser.swatchesNameText", Logo.messages
				.getString("echantillon"));

		UIManager.put("ColorChooser.hsbNameText", Logo.messages
				.getString("hsb"));
		UIManager.put("ColorChooser.hsbBlueText", Logo.messages
				.getString("hsbbleu"));
		UIManager.put("ColorChooser.hsbGreenText", Logo.messages
				.getString("hsbvert"));
		UIManager.put("ColorChooser.hsbRedText", Logo.messages
				.getString("hsbrouge"));

		UIManager.put("ColorChooser.swatchesRecentText", Logo.messages
				.getString("dernier"));
		UIManager.put("ColorChooser.previewText", Logo.messages
				.getString("apercu"));
		UIManager.put("ColorChooser.sampleText", Logo.messages
				.getString("echantillon_texte"));
		UIManager.put("ColorChooser.okText", Logo.messages.getString("ok"));
		UIManager.put("ColorChooser.resetText", Logo.messages
				.getString("restaurer"));
		UIManager.put("ColorChooser.cancelText", Logo.messages
				.getString("annuler"));
		UIManager.put("ColorChooser.previewText", Logo.messages
				.getString("apercu"));

		/*
		 * UIManager.put("Menu.font", Logo.police);
		 * UIManager.put("MenuItem.font", Logo.police);
		 * 
		 * UIManager.put("Label.font",new
		 * javax.swing.plaf.FontUIResource(Logo.police));
		 * UIManager.put("Button.font", new
		 * javax.swing.plaf.FontUIResource(Logo.police));
		 * UIManager.put("OptionPane.font", new
		 * javax.swing.plaf.FontUIResource(Logo.police));
		 * 
		 * UIManager.put("TextArea.font", Logo.police);
		 * UIManager.put("ComboBox.font", Logo.police);
		 * UIManager.put("List.font", Logo.police);
		 * UIManager.put("CheckBox.font", Logo.police);
		 * UIManager.put("TabbedPane.font", new
		 * javax.swing.plaf.FontUIResource(Logo.police));
		 * UIManager.put("TabbedPane.Font", new
		 * javax.swing.plaf.FontUIResource(Logo.police));
		 * UIManager.put("TabbedPane.tabFont", new
		 * javax.swing.plaf.FontUIResource(Logo.police));
		 */
		UIManager.put("ColorChooser.font", new javax.swing.plaf.FontUIResource(
				Logo.police));
		//		System.out.println(UIManager.get("ColorChooser.font"));
		// On change la police et le texte de tous les composants texte
		UIManager.put("OptionPane.buttonFont", Logo.police);
		commande.setFont(Logo.police);
		jMenuFile.setFont(Logo.police);
		jMenuFileEnregistrer_sous.setFont(Logo.police);
		jMenuFileNouveau.setFont(Logo.police);
		jMenuHelp.setFont(Logo.police);
		jMenuHelpLicence.setFont(Logo.police);
		jMenuHelpAbout.setFont(Logo.police);
		jMenuHelplicencefrancais.setFont(Logo.police);
		jLabel1.setFont(Logo.police);
		jMenuEdition.setFont(Logo.police);
		jMenuEditionCopier.setFont(Logo.police);
		jMenuEditionColler.setFont(Logo.police);
		jMenuEditionCouper.setFont(Logo.police);
		jMenuFileOuvrir.setFont(Logo.police);
		jMenuFileEnregistrer.setFont(Logo.police);
		jMenuFileQuitter.setFont(Logo.police);
		jMenuCapture.setFont(Logo.police);
		jMenuZoneTexte.setFont(Logo.police);
		jMenuZoneTexteItem.setFont(Logo.police);
		jMenuItem1.setFont(Logo.police);
		jMenuItem2.setFont(Logo.police);
		jMenuItem3.setFont(Logo.police);
		jMenuOptions.setFont(Logo.police);
		jMenuOptionsDemarrage.setFont(Logo.police);
		jMenuOptionsCouleurCrayon.setFont(Logo.police);
		jMenuOptionsCouleurFond.setFont(Logo.police);
		jMenuOptionsPreference.setFont(Logo.police);
		jMenuOptionsTraduction.setFont(Logo.police);
		this.panneauHistorique1.bediteur.setFont(Logo.police);
		this.panneauHistorique1.bstop.setFont(Logo.police);
		editeur.zonedition.setFont(Logo.police);
		this.panneauHistorique1.historique.setFont(Logo.police);

		jMenuFile.setText(Logo.messages.getString("fichier"));
		jMenuFileEnregistrer_sous.setText(Logo.messages
				.getString("enregistrer_sous"));
		jMenuFileNouveau.setText(Logo.messages.getString("nouveau"));
		jMenuHelp.setText(Logo.messages.getString("aide"));
		jMenuHelpLicence.setText(Logo.messages.getString("licence"));
		jMenuHelpAbout.setText(Logo.messages.getString("a_propos"));
		jMenuHelplicencefrancais.setText(Logo.messages
				.getString("licence_francais"));
		jLabel1.setText(Logo.messages.getString("commande") + "  ");
		jMenuEdition.setText(Logo.messages.getString("edition"));
		jMenuEditionCopier.setText(Logo.messages.getString("copier"));
		jMenuEditionColler.setText(Logo.messages.getString("coller"));
		jMenuEditionCouper.setText(Logo.messages.getString("couper"));
		jMenuFileOuvrir.setText(Logo.messages.getString("ouvrir"));
		jMenuFileEnregistrer.setText(Logo.messages.getString("enregistrer"));
		jMenuFileQuitter.setText(Logo.messages.getString("quitter"));
		jMenuCapture.setText(Logo.messages.getString("captureimage"));
		jMenuZoneTexte.setText(Logo.messages.getString("zone_de_texte"));
		jMenuZoneTexteItem.setText(Logo.messages.getString("enregistrer_rtf"));		
		jMenuItem1.setText(Logo.messages.getString("copier_image"));
		jMenuItem2.setText(Logo.messages.getString("enregistreimage"));
		jMenuItem3.setText(Logo.messages.getString("imprimer"));
		jMenuOptions.setText(Logo.messages.getString("options"));
		jMenuOptionsDemarrage.setText(Logo.messages
				.getString("definir_demarrage"));
		jMenuOptionsCouleurCrayon.setText(Logo.messages
				.getString("couleurcrayon"));
		jMenuOptionsCouleurFond.setText(Logo.messages.getString("couleurfond"));
		jMenuOptionsTraduction.setText(Logo.messages
				.getString("traduire_procedure"));
		jMenuOptionsPreference.setText(Logo.messages.getString("preferences"));
		this.panneauHistorique1.bediteur.setText(Logo.messages
				.getString("editeur"));
		this.panneauHistorique1.bstop.setText(Logo.messages.getString("stop"));
		jpop.setText();
		this.panneauHistorique1.historique.setText();
		//		JColorChooser jc=new JColorChooser();
		//		affiche_nom(jc);
	}

	/*
	 * void affiche_nom(Component jc){ jc.setFont(Logo.police);
	 * System.out.println(jc.getName()); if (jc instanceof Container){ int
	 * nb=((Container)jc).getComponentCount(); for (int i=0;i <nb;i++){
	 * Component jcbis=((Container)jc).getComponent(i);
	 * System.out.println(jcbis.getFont()); affiche_nom(jcbis); } } }
	 */

	/** Remplac, ainsi nous pouvons sortir quand la fentre est ferme */
	protected void processWindowEvent(WindowEvent e) {
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			setVisible(true);
			String[] choix = { Logo.messages.getString("ok"),
					Logo.messages.getString("annuler") };
			JLabel jlab = new JLabel(Logo.messages.getString("quitter?"));
			jlab.setFont(Logo.police);
			ImageIcon icone = new ImageIcon(Cadre.class
					.getResource("icone.png"));
			int retval = JOptionPane.showOptionDialog(this, jlab, Logo.messages
					.getString("quitter"), JOptionPane.OK_CANCEL_OPTION,
					JOptionPane.QUESTION_MESSAGE, icone, choix, choix[0]);
			if (retval == JOptionPane.OK_OPTION) {
				// On crit le fichier de configuration
				ecris_config();
				System.exit(0);
			}
		} else {
			super.processWindowEvent(e);
		}
	}

	// Ecrire le fichier de configuration lorsque l'on quitte XLOGO
	void ecris_config() {
		try {
			FileWriter file = new FileWriter(System.getProperty("user.home")
					+ File.separator + ".xlogo");
			BufferedWriter bfile = new BufferedWriter(file);
			int eff = 0;
			if (Logo.effacer_dessin)
				eff = 1;
			else
				eff = 0;
			String st = "# langue\n" + Logo.langage + "\n# vitesse\n"
					+ Logo.vitesse + "\n# tortue choisie\n"
					+ Logo.tortue_choisie + "\n# nb max de tortues\n"
					+ Logo.tortues + "\n# forme crayon\n" + Logo.forme_crayon
					+ "\n# effacer dessin en quittant editeur\n" + eff
					+ "\n# epaisseur max crayon\n" + Logo.epaisseur_max
					+ "\n# repertoire par defaut\n" + LancePrimitive.SortieTexte(Logo.repertoire_defaut)
					+ "\n# a executer au demarrage\n" + Logo.a_executer
					+ "\n# police\n" + Logo.police.getName() + "\n"
					+ Logo.police.getSize() + "\n# largeur\n"
					+ Logo.largeur_dessin + "\n# hauteur\n"
					+ Logo.hauteur_dessin + "\n# memoire\n"+Logo.tmp_memoire
					+"\n# qualite\n"+Logo.qualite+"\n# coloration\n"+Logo.COLOR_ENABLED+" "+Logo.coloration_commentaire+" "+
					Logo.coloration_operande+" "+Logo.coloration_parenthese+" "+Logo.coloration_primitive+" "
					+Logo.style_commentaire+" "+Logo.style_operande+" "+Logo.style_parenthese+" "+Logo.style_primitive
					+"\n# fichiers de demarrage\n";
			while (!Logo.path.isEmpty()) {
				st += Logo.path.pop().toString() + "\n";
			}
			st += "# fin";

			bfile.write(st);
			bfile.close();
		} catch (Exception ex) {
		}

	}

	// Ce qu'il se passe en validant dans la zone de texte
	void commande_actionPerformed() {
	//	System.out.println("commandeTotal :"+Runtime.getRuntime().totalMemory()/1024/1024+" Free "+Runtime.getRuntime().freeMemory()/1024/1024);
		// Si une parenthese tait slectionne, on dsactive la dcoloration
		commande.active=false;
		if (stop)
			stop = false;
		String texte = commande.getText();
		if (!texte.equals("") && commande.isEditable()) {
			if (touche.tape) {
				touche.tape = false;
				pile_historique.pop();
			}
			if (pile_historique.size() > 49)
				pile_historique.remove(0);
			pile_historique.push(texte); // On rajoute ce texte  l'historique
			index_historique = pile_historique.size(); //on rajuste l'index de
			// l'historique

			panneauHistorique1.ecris("normal", texte + "\n");
			
			// On enlve les ventuels commentaires
			int a =texte.indexOf("#");
			while (a!=-1){
				if (a==0) {texte="";break;}
				else if (!texte.substring(a-1,a).equals("\\")){
					texte=texte.substring(0,a);
					break;
				} 
				a =texte.indexOf("#",a+1);
			}
			affichage = new Affichage(this, decoupe(texte));
			affichage.start();
			// On efface la ligne de commande
			SwingUtilities.invokeLater(new Runnable(){
				public void run(){
					commande.setText("");					
				}
			});

		}
	}

	static StringBuffer decoupe(String st) { //Supprime les enchainements d'espaces inutiles et modifie le caractre \ en \\ 
		StringBuffer buffer = new StringBuffer();
		boolean espace=false;
		boolean backslash=false;
		boolean mot=false;
		int crochet_liste=0;
		boolean variable=false;
		boolean execution_lancee=Affichage.execution_lancee;
		for(int i=0;i<st.length();i++){
			char c=st.charAt(i);
			if (c==' ') {
				if (!espace&&buffer.length()!=0) {
					if (backslash) buffer.append("\\e");
					else {
						buffer.append(c);
						espace=true;
						mot=false;
						variable=false;
					}
					backslash=false;
				}
			}
			else if(c=='\\'&&!backslash) {
				espace=false;
				backslash=true;
			}
			else if(c=='\"'){
				if (espace&&crochet_liste<=0){
					mot=true;
				}
				buffer.append(c);
				espace=false;
				backslash=false;
			}
			else if (c==':'){
				if (espace&&crochet_liste<=0){
					variable=true;
				}
				buffer.append(c);
				espace=false;
				backslash=false;
			}
			else if (c=='['||c==']'||c=='('||c==')'){
				//Modifications apportes
				if (backslash) {
					buffer.append("\\"+c);
					backslash=false;
				}
				else {
					if (c=='[') crochet_liste++;
					else if (c==']') crochet_liste--;
					if (espace||buffer.length()==0) {buffer.append(c+" ");espace=true;}
					else {
						buffer.append(" "+c+" ");
						espace=true;
					}
				}
			}
			else if (c=='+'||c=='-'||c=='*'||c=='/'||c=='='||c=='<'||c=='>'||c=='&'||c=='|'){
				//  modifier (test + fin)
				if (mot||crochet_liste>0) buffer.append(c);
				else { 
					if (espace) buffer.append(c+" ");
					else {
						espace=true;
						buffer.append(" "+c+" ");
					}
				}
			}
			else{
				if (backslash){
					if (c=='n')	buffer.append("\\n");
					else if (c=='\\') buffer.append("\\\\"); 
					else if (c=='v'&& execution_lancee) buffer.append("\"");
					else if(c=='e'&& execution_lancee) buffer.append("\\e");
					else if (c=='#') buffer.append("\\#");
					else { 
						buffer.append(c);
					}
				}
				else {
					buffer.append(c);	
				}
				backslash=false;
				espace=false;
			}
		}
		//System.out.println(buffer);
		return (buffer);
	}

	class Touche extends KeyAdapter {
		int car = -1;

		boolean tape = false;

		public void keyPressed(KeyEvent e) {
			int ch = e.getKeyChar();
			int code =e.getKeyCode();
			if (commande.isEditable()) {
				if (code == KeyEvent.VK_UP) {
					if (index_historique > 0) {
						if (index_historique == pile_historique.size()) {
							tape = true;
							pile_historique.push(commande.getText());
						}
						index_historique--;
						commande.setText(pile_historique.get(index_historique)
								.toString());
					} else
						index_historique = 0;
				}
				else if (code == KeyEvent.VK_DOWN) {
					if (index_historique < pile_historique.size() - 1) {
						index_historique++;
						commande.setText(pile_historique.get(index_historique)
								.toString());
					} else
						index_historique = pile_historique.size() - 1;
				}
			} else {
				if (ch!=65535)	car = ch;
				else car=-code;
			}
		}
	}

	class PopupListener extends MouseAdapter {

		public void mousePressed(MouseEvent e) {
			maybeShowPopup(e);
		}

		public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
		}

		private void maybeShowPopup(MouseEvent e) {
			if (e.isPopupTrigger()) {
				jpop.show(e.getComponent(), e.getX(), e.getY());
			}
		}
	}
}